<script lang="ts" setup>
import type { CreateOrderType, PaymentRowType } from '../types';

import { computed } from 'vue';

import { reconciliateBillsApi } from '#/api/posting';

import { useCardListForm } from '../composables/useCardListForm';
import { useCardListGrid } from '../composables/useCardListGrid';

const props = withDefaults(
  defineProps<{
    payment: PaymentRowType | undefined;
    selectedData: CreateOrderType[] | undefined;
    tabKey: string;
  }>(),
  {},
);

const emit = defineEmits(['completeCheck', 'deletedChecked']);

interface RowType {
  id: string;
  price: number;
  productName: string;
}

function transformData(rows: RowType[]) {
  return rows.map((row) => ({
    id: row.id,
    courseId: '',
    tel: '',
    come: '1',
    orderType: '3',
    paymentId: props.payment?.id || '',
    productName: row.productName,
    productId: row.id.slice(1),
    catalogueId: '',
    orderMoney: String(row.price),
    realMoney: String(props.payment?.fee) || '',
    districtMoney: '',
    startTime: '',
    endTime: '',
  }));
}

const { formOptions } = useCardListForm({
  schema: [
    {
      component: 'Input',
      componentProps: { allowClear: true },
      fieldName: 'productName',
      defaultValue: '',
      label: '商品名称',
    },
  ],
});

const { Grid, cancelCheck, setChecked } = useCardListGrid<RowType, CreateOrderType>({
  payment: computed(() => props.payment),
  selectedData: computed(() => props.selectedData),
  rowKey: 'id',
  rowKeyPrefix: props.tabKey,
  columns: [
    { type: 'checkbox', width: 60 },
    { field: 'productName', title: '商品名称', minWidth: 150 },
    { field: 'price', title: '金额', minWidth: 100 },
  ],
  query: reconciliateBillsApi.getWumenPhysicalBuyList,
  transformData,
  emit,
  formOptions,
});

defineExpose({ cancelCheck, setChecked });
</script>

<template>
  <div class="orders-container h-full">
    <Grid />
  </div>
</template>
